package client;

import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.rise.finewebservice.FineService;
import com.rise.finewebservice.entity.FineType;
import com.rise.finewebservice.entity.PenaltyForDelay;
import com.rise.loanwebservice.LoanService;
import com.rise.loanwebservice.entity.Loan;

public class FineServiceClient {
	
	public FineServiceClient(){
		
	}
	
	public static void main(String[] args) {
		ClassPathXmlApplicationContext context = new ClassPathXmlApplicationContext(
				new String[] {"client/client-beans.xml"});
		
		FineService fineService = (FineService) context.
				getBean("clientFineService");
		
		LoanService loanService = (LoanService) context.
			getBean("clientFineService");
		
		Loan loan = loanService.getLoan(8);
		
		Object[] paramsDelay = new Object[3];
		paramsDelay[0] = 29;
		paramsDelay[1] = 6;
		paramsDelay[2] = loan.getLoanDate();

		PenaltyForDelay delay = (PenaltyForDelay) fineService.
			getDelegateFine().doStrategy(FineType.PENALTY_FOR_DELAY);

		delay.setFineValue(4.0);
		double calculatedFineValue = delay.calculateFineValue(paramsDelay);

		delay.setCalculatedFineValue(calculatedFineValue);

		fineService.addFine(delay);
	}
}
