package com.rise.authenticationwebservice;

import javax.jws.WebService;
import javax.xml.bind.annotation.XmlSeeAlso;

import com.rise.authenticationwebservice.impl.CardAuthentication;
import com.rise.authenticationwebservice.impl.FingerPrintAuthentication;
import com.rise.authenticationwebservice.impl.PasswordAuthentication;

/**
 * 
 * @author Heberth Braga
 *
 */
@WebService(endpointInterface = "com.rise.authenticationwebservice.AuthenticationService")
@XmlSeeAlso({PasswordAuthentication.class, CardAuthentication.class, 
	FingerPrintAuthentication.class})
public class AuthenticationServiceImpl implements
	AuthenticationService {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 3936145524194273709L;
	
	private Authentication auth;
	
	public AuthenticationServiceImpl(Authentication auth){
		this.auth = auth;
	}
	
	@Override
	public boolean authenticate(){
		
		return this.auth.authenticate();
	}
}
