package com.rise.finewebservice.entity;

import java.io.Serializable;

import javax.xml.bind.annotation.XmlSeeAlso;

/**
 * 
 * @author Heberth Braga
 *
 */
@XmlSeeAlso({PenaltyForDelay.class, PenaltyForViolation.class})
public abstract class Fine implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -28347959466080297L;
	
	private Integer id;
	protected Double fineValue;
	private Double calculatedFineValue;
	
	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Double getFineValue() {
		return fineValue;
	}

	public void setFineValue(Double fineValue) {
		this.fineValue = fineValue;
	}

	/*
	 * Variation Point in which will be overridden in subclasses
	 */
	public abstract Double calculateFineValue(Object[] parameters);
	
	public Double getCalculatedFineValue() {
		return this.calculatedFineValue;
	}

	public void setCalculatedFineValue(Double calculatedFineValue) {
		this.calculatedFineValue = calculatedFineValue;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Fine other = (Fine) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}
}