package com.rise.finewebservice.entity;

import java.util.Calendar;
import java.util.GregorianCalendar;

/**
 * 
 * @author Heberth Braga
 *
 */
public class PenaltyForDelay extends Fine {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -3651441059341362803L;
	
	public PenaltyForDelay(){
		
	}
	
	@Override
	public Double calculateFineValue(Object[] parameters) {
		Integer dayOfMonth = (Integer) parameters[0];
		Integer month = (Integer) parameters[1];
		java.util.Date loanDate = (java.util.Date) parameters[2];

		Integer numberOfDays = calculateNumberDays(loanDate, dayOfMonth, month);

		return this.fineValue * numberOfDays;
	}
	
	private Integer calculateNumberDays(java.util.Date loanDate, int dayOfMonth, int month){
		
		Calendar deliveryDate = new GregorianCalendar();
		
		deliveryDate.set(com.rise.finewebservice.entity.Date.getDayOfMonth(), dayOfMonth);
		deliveryDate.set(com.rise.finewebservice.entity.Date.getMonth(), month);
		
		Long diff = deliveryDate.getTimeInMillis() - loanDate.getTime();
		diff = diff / 100 / 60 / 60 / 24;
		
		return Integer.valueOf(diff.toString());
	}
}