package com.rise.itemwebservice;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.jws.soap.SOAPBinding.Style;
import javax.jws.soap.SOAPBinding.Use;

import com.rise.itemwebservice.entity.Category;
import com.rise.itemwebservice.entity.Item;
import com.rise.itemwebservice.entity.ItemDetails;

/**
 * 
 * @author Heberth Braga
 *
 */

@WebService
@SOAPBinding(style = Style.DOCUMENT, use = Use.LITERAL)
public interface ItemService extends Serializable {
	
	void addItem(Item item);
	
	void updateItem(Item item);
	
	Item getItem(Integer id);
	
	List<Item> getItens();
	
	Category getCategory(Integer id);
	
	List<Category> getCategories();
	
	void insertItemDetails(ItemDetails details);
	
	Collection<Object> loadItemDetails(ItemDetails details);
	
	Collection<ItemDetails> getItemDetails();
	
	void addCategory(Category category);
}
