package com.rise.loanwebservice;

import java.io.Serializable;
import java.util.List;
import java.util.Set;

import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.jws.soap.SOAPBinding.Style;
import javax.jws.soap.SOAPBinding.Use;

import com.rise.itemwebservice.entity.Item;
import com.rise.loanwebservice.entity.Loan;
import com.rise.usercomponent.entity.User;

/**
 * 
 * @author Heberth Braga
 *
 */

@WebService
@SOAPBinding(style = Style.DOCUMENT, use = Use.LITERAL)
public interface LoanService extends Serializable {
	
	void addLoan(Loan loan);
	
	Loan getLoan(Integer id);
	
	List<Loan> getLoans();
	
	Set<Loan> getLoanByUser(User user);
	
	void returnLoanItem(Loan loan);
	
	Set<Item> getItensLoan(Loan loan);
	
	void setFineMonth(Integer fineMonth);

	void setFineDayofMonth(Integer fineDayofMonth);
	
	void calculateFineDelay(Double fineValue, Loan loan);
}
