package com.rise.persistence;

import java.util.Collection;
import java.util.List;

/**
 * 
 * @author Heberth Braga

 * Generic persitence service.
 *
 */
public interface Persistence<T> {

	void save(T entity);
	
	void update(T entity);
	
	Object retrieve(Object pk);
	
	List<T> findAll();
	
	void remove(T entity);
	
	Collection<Object> retrieveByParameters(String str, 
			Collection<Object> parameters);
}