package com.rise.persistence.dao.impl;

import java.util.List;

import com.rise.persistence.dao.UserDao;
import com.rise.persistence.hibernate.GeneralDaoHibernate;
import com.rise.usercomponent.entity.User;

public class UserDaoImpl extends GeneralDaoHibernate<User> 
	implements UserDao {

	@SuppressWarnings("unchecked")
	@Override
	public Class getEntityClass() {
		
		return User.class;
	}

	@SuppressWarnings("unchecked")
	@Override
	public User getUserByName(String name) {
		
		String strQuery = "from User u where u.username = ?";

		List list = getHibernateTemplate().find(strQuery, name);

		if(list != null && list.size() > 0)
			return (User) list.get(0);
		else
			return null;
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<Object> getUsersByParameters(String str, 
			Object[] parameters) {
		
		return getHibernateTemplate().find(str, parameters);
	}
}
