package com.rise.usercomponent;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import com.rise.usercomponent.entity.Profile;
import com.rise.usercomponent.entity.User;

public interface UserComponent extends Serializable {

	String getUserName(User user);
	
	void addUser(User user);
	
	User getUser(Integer id);
	
	List<User> getUsers();
	
	User getUserByName(String param);
	
	void addProfile(Profile profile);
	
	Profile getProfile(Integer id);
	
	List<Profile> getProfiles();
	
	Collection<Object> getUsersByParameters(String str, 
			Object[] parameters);
	
	void removeProfile(Profile profile);
	
	void removeUser(User user);
	
	void updateUser(User user);
	
	void updateProfile(Profile profile);
	
	boolean validateUser(String email, String password);
}