package authenticationwebservice;

import org.junit.Before;
import org.junit.Test;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import static org.junit.Assert.assertThat;
import static org.hamcrest.core.Is.is;

import com.rise.authenticationwebservice.AuthenticationService;
import com.rise.authenticationwebservice.impl.PasswordAuthentication;
import com.rise.usercomponent.entity.User;

/**
 * 
 * @author Heberth Braga
 *
 */
public class AuthenticationWebServiceTest {
	
	private ClassPathXmlApplicationContext services;
	private ClassPathXmlApplicationContext springContext;
	private AuthenticationService authService;
	private PasswordAuthentication auth;
	
	@Before
	public void setUp(){
		services = new ClassPathXmlApplicationContext(
				new String[] {"client/client-beans.xml"});
		
		springContext = new ClassPathXmlApplicationContext(
				new String[] {"beans.xml", "beans-persistence.xml"});
		
		authService = (AuthenticationService) services.
				getBean("clientAuthService");
		
		auth = (PasswordAuthentication) springContext.getBean("auth");
	}
	
	@Test
	public void testAuthenticateUser(){
		User user = new User();
		user.setEmail("foo@gmail.com");
		user.setPassword("1234");
		
		auth.setUser(user);
		
		boolean isAuthorized = authService.authenticate();
		
		assertThat(isAuthorized, is(true));
	}
}
