package container;

import static org.junit.Assert.assertThat;
import static org.hamcrest.core.Is.is;

import org.junit.Before;
import org.junit.Test;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.rise.authenticationwebservice.AuthenticationService;
import com.rise.finewebservice.FineService;
import com.rise.itemwebservice.ItemService;
import com.rise.loanwebservice.LoanService;
import com.rise.usercomponent.UserComponent;

/**
 * 
 * @author Heberth Braga
 *
 */
public class ContainerTest {
	
	private ClassPathXmlApplicationContext context;
	
	@Before
	public void setUp(){
		context = new ClassPathXmlApplicationContext(
				new String[] {"client/client-beans.xml"});
	}
	
	@Test
	public void testPing(){
		UserComponent userService = (UserComponent) context.getBean(
				"clientUserService");
			
		FineService fineService = (FineService) context.getBean(
				"clientFineService");
		
		ItemService itemService = (ItemService) context.getBean(
				"clientItemService");
		
		LoanService loanService = (LoanService) context.getBean(
				"clientLoanService");
		
		AuthenticationService authService = (AuthenticationService) context.
				getBean("clientAuthService");
		
		assertThat(userService != null, is(true));
		assertThat(fineService != null, is(true));
		assertThat(itemService != null, is(true));
		assertThat(loanService != null, is(true));
		assertThat(authService != null, is(true));
	}
}
