package com.rise.finewebservice;

import java.util.List;

import javax.jws.WebService;

import com.rise.persistence.PersistenceFactory;
import com.rise.persistence.dao.FineDao;

/**
 * 
 * @author Heberth Braga
 *
 */

@WebService(endpointInterface = "com.rise.finewebservice.FineService")
public class FineServiceImpl implements FineService {

	private FineDao fineDao;
	
	public FineServiceImpl(PersistenceFactory persistenceFactory){
		this.fineDao = persistenceFactory.
				getFineDao();
	}

	@Override
	public void addFine(Fine fine) {
		this.fineDao.save(fine);
	}

	@Override
	public void deleteFine(Fine fine) {
		this.fineDao.remove(fine);
	}

	@Override
	public Fine getFine(Integer id) {
		
		return (Fine) this.fineDao.
				retrieve(id);
	}

	@Override
	public List<Fine> getFines() {
		
		return this.fineDao.findAll();
	}
}
