package com.rise.itemwebservice;

import java.io.Serializable;
import java.util.Collection;
import java.util.Set;

import com.sun.xml.bind.CycleRecoverable;

/**
 * 
 * @author Heberth Braga
 *
 */
public class Category implements Serializable, CycleRecoverable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -4683880668849784043L;
	
	private Integer categoryId;
	private String name;
	private Double value;
	private Integer returnDays;
	private Set<Item> itens;
	
	public Category(){

	}
	
	public Collection<Item> getItens(){
		return this.itens;
	}
	
	public void setItens(Set<Item> itens){
		this.itens = itens;
	}
	
	public Integer getCategoryId() {
		return this.categoryId;
	}

	public void setCategoryId(Integer categoryId) {
		this.categoryId = categoryId;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Double getValue() {
		return value;
	}
	
	public void setValue(Double value) {
		this.value = value;
	}
	
	public Integer getReturnDays() {
		return returnDays;
	}

	public void setReturnDays(Integer returnDays) {
		this.returnDays = returnDays;
	}
	
	@Override
	public String toString(){
		return this.categoryId.toString();
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((categoryId == null) ? 0 : categoryId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Category other = (Category) obj;
		if (categoryId == null) {
			if (other.categoryId != null)
				return false;
		} else if (!categoryId.equals(other.categoryId))
			return false;
		return true;
	}

	@Override
	public Category onCycleDetected(Context context) {
		Category replacement = new Category();
		replacement.categoryId = this.categoryId;
		
		return replacement;
	}
}
