package com.rise.itemwebservice;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.jws.soap.SOAPBinding.Style;
import javax.jws.soap.SOAPBinding.Use;

/**
 * 
 * @author Heberth Braga
 *
 */

@WebService
@SOAPBinding(style = Style.DOCUMENT, use = Use.LITERAL)
public interface ItemService extends Serializable {
	
	public void addItem(Item item);
	
	public void updateItem(Item item);
	
	public Item getItem(Integer id);
	
	public List<Item> getItens();
	
	public Category getCategory(Integer id);
	
	public List<Category> getCategories();
	
	public void insertItemDetails(ItemDetails details);
	
	public Collection<Object> loadItemDetails(ItemDetails details);
	
	public Collection<ItemDetails> getItemDetails();
	
	public void addCategory(Category category);
}
