package com.rise.itemwebservice;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import javax.jws.WebService;

import com.rise.persistence.PersistenceFactory;
import com.rise.persistence.dao.CategoryDao;
import com.rise.persistence.dao.ItemDao;
import com.rise.persistence.dao.ItemDetailsDao;

/**
 * 
 * @author Heberth Braga
 *
 */

@WebService(endpointInterface = "com.rise.itemwebservice.ItemService")
public class ItemServiceImpl implements ItemService {

	/**
	 * 
	 */
	private static final long serialVersionUID = 8608478849886113385L;
	
	private ItemDao itemDao;
	private CategoryDao categoryDao;
	private ItemDetailsDao itemDetailsDao;
	
	public ItemServiceImpl(PersistenceFactory persistenceFactory){
		this.itemDao = persistenceFactory.getItemDao();
		this.categoryDao = persistenceFactory.getCategoryDao();
		this.itemDetailsDao = persistenceFactory.getItemDetailsDao();
	}
	
	@Override
	public Collection<ItemDetails> getItemDetails(){
	
		Collection<ItemDetails> detailsType = new ArrayList<ItemDetails>();
		
		detailsType.add(null);

		return detailsType;
	}

	@Override
	public void addItem(Item item) {
		this.itemDao.save(item);
	}

	@Override
	public List<Category> getCategories() {
		
		return this.categoryDao.findAll();
	}

	@Override
	public Category getCategory(Integer id) {
		
		return (Category) this.categoryDao.retrieve(id);
	}

	@Override
	public Item getItem(Integer id) {
		
		return (Item) this.itemDao.retrieve(id);
	}

	@Override
	public List<Item> getItens() {
		
		return this.itemDao.findAll();
	}

	@Override
	public void insertItemDetails(ItemDetails details) {
		this.itemDetailsDao.save(details);
	}

	@Override
	public Collection<Object> loadItemDetails(ItemDetails details){
		
		return this.itemDetailsDao.loadItemDetails(details);
	}

	@Override
	public void updateItem(Item item) {
		this.itemDao.update(item);
	}

	@Override
	public void addCategory(Category category) {
		this.categoryDao.save(category);
	}
}
