package com.rise.loanwebservice;

import java.io.Serializable;
import java.util.List;
import java.util.Set;

import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.jws.soap.SOAPBinding.Style;
import javax.jws.soap.SOAPBinding.Use;

import com.rise.finewebservice.Fine;
import com.rise.itemwebservice.Item;
import com.rise.userwebservice.User;

/**
 * 
 * @author Heberth Braga
 *
 */

@WebService
@SOAPBinding(style = Style.DOCUMENT, use = Use.LITERAL)
public interface LoanService extends Serializable {
	
	public void addLoan(Loan loan);
	
	public Loan getLoan(Integer id);
	
	public List<Loan> getLoans();
	
	public Set<Loan> getLoanByUser(User user);
	
	public void returnLoanItem(Loan loan);
	
	public Set<Item> getItensLoan(Loan loan);
	
	public void addFine(Fine fine);
	
	public void calculateFine(Double fineValue);
}
