package com.rise.persistence.dao.impl;

import java.util.ArrayList;
import java.util.Collection;

import com.rise.itemwebservice.Comment;
import com.rise.itemwebservice.ItemDetails;
import com.rise.persistence.dao.ItemDetailsDao;
import com.rise.persistence.hibernate.GeneralDaoHibernate;

/**
 * 
 * @author Heberth Braga
 *
 */
public class CommentDaoImpl extends GeneralDaoHibernate<ItemDetails> 
	implements ItemDetailsDao {

	@SuppressWarnings("unchecked")
	@Override
	public Class getEntityClass() {
		
		return Comment.class;
	}

	@Override
	public Collection<Object> loadItemDetails(ItemDetails details) {
		
		String query = "select c.text, c.user.email, c.item.name, c.nickname from Comment c " +
		" where c.item.itemId = :param0";

		Collection<Object> parameters = new ArrayList<Object>();
				parameters.add(details.getItem().getItemId());

		Collection<Object> result = this.retrieveByParameters(query, 
				parameters);

		return result;
	}
}
