package com.rise.userwebservice;

import java.io.Serializable;
import java.util.Set;

import com.sun.xml.bind.CycleRecoverable;

/**
 * 
 * @author Heberth Braga
 *
 */
public class Profile implements Serializable, CycleRecoverable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -201403760259768866L;
	
	private Integer profileId;
	private String name;
	private String description;
	private Set<User> users;
	
	public Profile(){
		
	}
	
	public void setUsers(Set<User> users){
		this.users = users;
	}
	
	public Set<User> getUsers(){
		return this.users;
	}
	
	public Integer getProfileId(){
		return this.profileId;
	}
	
	public void setProfileId(Integer profileId){
		this.profileId = profileId;
	}
	
	public String getName(){
		return this.name;
	}
	
	public void setName(String name){
		this.name = name;
	}
	
	public String getDescription(){
		return this.description;
	}
	
	public void setDescription(String description){
		this.description = description;
	}
	
	@Override
	public String toString(){
		return this.profileId.toString();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((profileId == null) ? 0 : profileId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Profile other = (Profile) obj;
		if (profileId == null) {
			if (other.profileId != null)
				return false;
		} else if (!profileId.equals(other.profileId))
			return false;
		return true;
	}
	
	// this method is called by JAXB when a cycle is detected
	@Override
	public Profile onCycleDetected(Context context) {
		Profile replacement = new Profile();
		
		// when a cycle is detected, let's just write out an ID
		replacement.profileId = this.profileId;
		
		return replacement;
	}
}
