package com.rise.userwebservice;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.jws.soap.SOAPBinding.Style;
import javax.jws.soap.SOAPBinding.Use;

@WebService
@SOAPBinding(style=Style.DOCUMENT, use=Use.LITERAL)
public interface UserService extends Serializable {

	public String getUserName(User user);
	
	public void addUser(User user);
	
	public User getUser(Integer id);
	
	public List<User> getUsers();
	
	public User getUserByName(String param);
	
	public void addProfile(Profile profile);
	
	public Profile getProfile(Integer id);
	
	public List<Profile> getProfiles();
	
	public Collection<Object> getUsersByParameters(String str, 
			Object[] parameters);
	
	public void removeProfile(Profile profile);
	
	public void removeUser(User user);
	
	public void updateUser(User user);
	
	public void updateProfile(Profile profile);
	
	public boolean validateUser(String email, String password);
}
