package com.rise.authenticationwebservice;

import static org.hamcrest.core.Is.is;
import static org.junit.Assert.assertThat;

import org.junit.Before;
import org.junit.Test;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.rise.userwebservice.User;

/**
 * 
 * @author Heberth Braga
 *
 */
public class AuthenticationWebServiceTest {
	
	private ClassPathXmlApplicationContext context;
	private AuthenticationService authService;
	
	@Before
	public void setUp(){
		context = new ClassPathXmlApplicationContext(
				new String[] {"client/client-beans.xml"});
		
		authService = (AuthenticationService) context.
				getBean("clientAuthService");
	}
	
	@Test
	public void testAuthenticateUser(){
		
		User user = new User();
		user.setEmail("foo@gmail.com");
		user.setPassword("1234");
		
		Authentication auth = new PasswordAuthentication(user);
		
		authService.setAuthentication(auth);
		boolean isAuthorizedPassword = authService.authenticate();
		
		assertThat(isAuthorizedPassword, is(true));
	}
}
