package com.rise.authenticationbundleconfig;

import org.osgi.framework.BundleContext;

import com.rise.userbundle.User;

/**
 * 
 * @author Heberth Braga
 *
 */
public class AuthenticationTest {

	private BundleContext context = Activator.getDefault().getContext();
	private BundleContext userContext = com.rise.userbundle.Activator.
			getDefault().getContext();
	
	public void start() {
		
		AuthenticationService authService = (AuthenticationService) context.
				getService(context.getServiceReference(
						AuthenticationService.class.getName()));
		
		User user = (User) userContext.getService(context.getServiceReference(
				User.class.getName()));
		
		PropertiesFactory.getProps().loadFile("productConfig.properties");
		
		user.setEmail("foo@gmail.com");
		user.setPassword("1234");
		
		try {
			Authentication auth = PropertiesFactory.getProps().getType(user);
			
			authService.setAuthentication(auth);
			
			boolean isAuthorized = authService.authenticate();
			
			if(isAuthorized){
				System.out.println("User authenticated...");
			}
		} catch (AuthenticationTypeNotSupportedException e) {
			e.printStackTrace();
		}
	}
}
