package com.rise.authenticationstrategy;

import org.osgi.framework.BundleContext;

import com.rise.userbundle.Activator;
import com.rise.userbundle.User;
import com.rise.userbundle.UserService;

/**
 * 
 * @author Heberth Braga
 *
 */
public class PasswordAuthentication extends Authentication {
	
	private BundleContext userContext = Activator.getDefault().getContext();
	private User user;
	
	public PasswordAuthentication(User user){
		this.user = user;
	}
	
	@Override
	public boolean authenticate() {
		
		UserService userService = (UserService) userContext.getService(
				userContext.getServiceReference(UserService.class.getName()));
		
		return userService.validateUser(this.user.getEmail(), 
				this.user.getPassword());
	}
}
