package com.rise.authenticationbundlestrategy;

import org.osgi.framework.BundleContext;

import com.rise.authenticationstrategy.Activator;
import com.rise.authenticationstrategy.Authentication;
import com.rise.authenticationstrategy.AuthenticationService;
import com.rise.authenticationstrategy.PasswordAuthentication;
import com.rise.userbundle.User;

/**
 * 
 * @author Heberth Braga
 *
 */
public class AuthenticationTest {

	private BundleContext context = Activator.getDefault().getContext();
	private BundleContext userContext = com.rise.userbundle.Activator.
			getDefault().getContext();
	
	public void start() {
		
		AuthenticationService authService = (AuthenticationService) context.
				getService(context.getServiceReference(
						AuthenticationService.class.getName()));
		
		User user = (User) userContext.getService(context.getServiceReference(
				User.class.getName()));
		
		user.setEmail("foo@gmail.com");
		user.setPassword("1234");
		
		Authentication auth = new PasswordAuthentication(user);
		
		authService.setAuthentication(auth);
		boolean isAuthorized = authService.authenticate();
		
		if(isAuthorized)
			System.out.println("User authenticated!!");
		else
			System.out.println("Authentication failed...");
	}
}
