package com.rise.finebundleconfig;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

/**
 * 
 * @author Heberth Braga
 *
 */
public class PropertiesFactory {

	private static Properties props = new Properties();
	private static PropertiesFactory propsFactory;
	
	private PropertiesFactory(){
		
	}
	
	public synchronized static PropertiesFactory getProps(){
		if(propsFactory == null)
			propsFactory = new PropertiesFactory();
		
		return propsFactory;
	}
	
	public void loadFile(String file){
		File fileTemp = new File(file);
		
		try {
			FileInputStream input = new FileInputStream(fileTemp);
			props.load(input);	
			input.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public Fine getFineType(String key) throws FineTypeNotSupportedException{
		
		String keyTemp = props.getProperty(key);
		
		if(keyTemp.equals("0")){
			return new PenaltyForDelay();
		}else if(keyTemp.equals("1")){
			return new PenaltyForViolation();
		}
		
		throw new FineTypeNotSupportedException();
	}
}
