package com.rise.itembundle;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

/**
 * 
 * @author Heberth Braga
 *
 */
public interface ItemService extends Serializable {
	
	public void addItem(Item item);
	
	public void updateItem(Item item);
	
	public Item getItem(Integer id);
	
	public List<Item> getItens();
	
	public Category getCategory(Integer id);
	
	public List<Category> getCategories();
	
	public void insertComment(Comment comment);
	
	public Collection<Object> loadItemDetails(ItemDetails details);
	
	public Collection<ItemDetails> getItemDetails();
	
	public void addCategory(Category category);
	
	public void removeCategory(Category category);
	
	public void removeItem(Item item);
}
