package com.rise.itembundle;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import com.rise.itembundle.dao.CategoryDao;
import com.rise.itembundle.dao.ItemDao;
import com.rise.itembundle.dao.ItemDetailsDao;
import com.rise.itembundle.entity.ItemDetailsType;

/**
 * 
 * @author Heberth Braga
 *
 */
public class ItemServiceImpl implements ItemService {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 6609196342347487191L;
	
	private ItemDao itemDao;
	private CategoryDao categoryDao;
	private ItemDetailsDao<Comment> commentDao;
	private DelegateDetails delegateDetails;
	private Collection<ItemDetails> detailsType;

	public void setItemDao(ItemDao itemDao) {
		this.itemDao = itemDao;
	}

	public void setCategoryDao(CategoryDao categoryDao) {
		this.categoryDao = categoryDao;
	}
	
	public void setCommentDao(ItemDetailsDao<Comment> commentDao){
		this.commentDao = commentDao;
	}
	
	public void setDelegateDetails(DelegateDetails delegateDetails){
		this.delegateDetails = delegateDetails;
	}

	@Override
	public void addCategory(Category category) {
		this.categoryDao.saveCategory(category);
	}

	@Override
	public void addItem(Item item) {
		this.itemDao.saveItem(item);
	}

	@Override
	public List<Category> getCategories() {
		
		return this.categoryDao.getCategories();
	}

	@Override
	public Category getCategory(Integer id) {
	
		return this.categoryDao.getCategory(id);
	}

	@Override
	public Item getItem(Integer id) {
		
		return this.itemDao.getItem(id);
	}

	@Override
	public Collection<ItemDetails> getItemDetails() {

		this.detailsType = new ArrayList<ItemDetails>();
		
		this.detailsType.add(this.delegateDetails.getDetail(
				ItemDetailsType.COMMENT));
		this.detailsType.add(this.delegateDetails.getDetail(
				ItemDetailsType.REVIEW));
		
		return this.detailsType;
	}

	@Override
	public List<Item> getItens() {
		
		return this.itemDao.getItens();
	}

	@Override
	public void insertComment(Comment comment) {
		this.commentDao.saveItemDetails(comment);
	}
	
	@Override
	public Collection<Object> loadItemDetails(ItemDetails details) {
		
		return null;
	}

	@Override
	public void removeCategory(Category category) {
		this.categoryDao.removeCategory(category);
	}

	@Override
	public void removeItem(Item item) {
		this.itemDao.removeItem(item);
	}

	@Override
	public void updateItem(Item item) {
		this.itemDao.updateItem(item);
	}
}
