package com.rise.itembundle.dao.impl;

import java.util.Collection;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.rise.itembundle.Comment;
import com.rise.itembundle.dao.ItemDetailsDao;

/**
 * 
 * @author Heberth Braga
 *
 */
public class CommentDaoImpl extends HibernateDaoSupport 
		implements ItemDetailsDao<Comment> {

	@Override
	public void saveItemDetails(Comment details) {
		getHibernateTemplate().save(details);
	}

	@SuppressWarnings("unchecked")
	@Override
	public Collection<Object> loadComments(Comment details) {
		
		String query = "select c.text, c.user.email, c.item.name from Comment c " +
				" where c.item.itemId = ?";
		
		Object[] parameters = {details.getItem().getItemId()};
		
		Collection<Object> result = getHibernateTemplate().find(
				query, parameters);

		return result;
	}
}
