package com.rise.itembundleconfig;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

/**
 * 
 * @author Heberth Braga
 *
 */
public class PropertiesFactory {

	private static Properties props = new Properties();
	private static PropertiesFactory propsFactory;
	
	private PropertiesFactory(){
		
	}
	
	public synchronized static PropertiesFactory getProps(){
		if(propsFactory == null)
			propsFactory = new PropertiesFactory();
		
		return propsFactory;
	}
	
	public void loadFile(String file){
		File fileTemp = new File(file);
		
		try {
			FileInputStream input = new FileInputStream(fileTemp);
			props.load(input);	
			input.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public ItemDetails getDetailsType(String key) 
			throws ItemDetailsTypeNotFoundException{

		String keyTemp = props.getProperty(key);

		if(keyTemp.equals("no")){
			throw new ItemDetailsTypeNotFoundException("The product does not support this feature");
		}else {
			return new Comment();
		}
	}
}
