package com.rise.itembundleconfig.dao.impl;

import java.util.List;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.rise.itembundleconfig.dao.CategoryDao;
import com.rise.itembundleconfig.Category;
import com.rise.itembundleconfig.CategoryImpl;

/**
 * 
 * @author Heberth Braga
 *
 */
public class CategoryDaoImpl extends HibernateDaoSupport 
		implements CategoryDao {

	@SuppressWarnings("unchecked")
	@Override
	public List<Category> getCategories() {
		
		return getHibernateTemplate().loadAll(CategoryImpl.class);
	}

	@Override
	public Category getCategory(Integer id) {
		
		return (Category) getHibernateTemplate().get(
				CategoryImpl.class, id);
	}

	@Override
	public void removeCategory(Category category) {
		getHibernateTemplate().delete(category);
	}

	@Override
	public void saveCategory(Category category) {
		getHibernateTemplate().save(category);
	}

	@Override
	public void updateCategory(Category category) {
		getHibernateTemplate().update(category);
	}
}
