package com.rise.itembundleconfig.dao.impl;

import java.util.List;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.rise.itembundleconfig.Item;
import com.rise.itembundleconfig.ItemImpl;
import com.rise.itembundleconfig.dao.ItemDao;

/**
 * 
 * @author Heberth Braga
 *
 */
public class ItemDaoImpl extends HibernateDaoSupport 
	implements ItemDao {

	@Override
	public Item getItem(Integer id) {
		
		return (Item) getHibernateTemplate().get(ItemImpl.class, id);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<Item> getItens() {
		
		return getHibernateTemplate().loadAll(ItemImpl.class);
	}

	@Override
	public void saveItem(Item item) {
		getHibernateTemplate().save(item);
	}

	@Override
	public void updateItem(Item item) {
		getHibernateTemplate().update(item);
	}

	@Override
	public void removeItem(Item item) {
		getHibernateTemplate().delete(item);
	}
}
