package com.rise.loanbundle.dao.impl;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.rise.itembundle.Item;
import com.rise.loanbundle.Loan;
import com.rise.loanbundle.dao.LoanDao;
import com.rise.loanbundle.entity.LoanImpl;
import com.rise.userbundle.User;

/**
 * 
 * @author Heberth Braga
 *
 */
public class LoanDaoImpl extends HibernateDaoSupport 
		implements LoanDao {

	@SuppressWarnings("unchecked")
	@Override
	public Set<Item> getItensLoan(Loan loan) {
		
		String result = "Select l.itens from LoanImpl l where l.loanid " +
				"= ?";
		
		Object[] parameters = {loan.getLoanId()};

		Set<Item> itensList = new TreeSet<Item>();

		try {
			Collection<Object> collection = getHibernateTemplate().find(
					result, parameters);

			Iterator<Object> itResult = collection.iterator();

			while(itResult.hasNext()){
				Object obj = itResult.next();
				itensList.add((Item) obj);
			}

			return itensList;

		} catch (Exception e) {
			e.printStackTrace();
		}

		return null;
	}

	@SuppressWarnings("unchecked")
	@Override
	public Set<Loan> getLoanByUser(User user) {
		
		String result = "from LoanImpl l where l.user.username = ?";
		
		Object[] parameters = {user.getUsername()};
		
		Set<Loan> loansList = new TreeSet<Loan>();
		
		try {
			Collection<Object> collection = getHibernateTemplate().find(
					result, parameters);
			
			Iterator<Object> itResult = collection.iterator();
			
			while(itResult.hasNext()){
				Object obj = itResult.next();
				loansList.add((Loan) obj);
			}
			
			return loansList;
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return null;
	}

	@Override
	public Loan getLoanbyId(Integer id) {
		
		return (Loan) getHibernateTemplate().get(LoanImpl.class, 
				id);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<Loan> getLoans() {
		
		return getHibernateTemplate().loadAll(LoanImpl.class);
	}

	@Override
	public void saveLoan(Loan loan) {
		getHibernateTemplate().save(loan);
	}

	@Override
	public void updateLoan(Loan loan) {
		getHibernateTemplate().update(loan);
	}
}
