package com.rise.loanbundlestrategy;

import java.util.Date;
import java.util.Set;

import com.rise.finebundlestrategy.Fine;
import com.rise.itembundlestrategy.Item;
import com.rise.userbundle.User;

/**
 * 
 * @author Heberth Braga
 *
 */

public class LoanImpl implements Comparable<Object>, Loan {
	
	private Integer loanId;
	private Date loanDate;
	private Date returnDate;
	private Date plannedReturnDate;
	private Double loanValue;
	private Set<Item> itens;
	private User user;
	private Fine fine;
	
	public LoanImpl(){
		
	}
	
	public void setLoanId(Integer loanId){
		this.loanId = loanId;
	}
	
	public Integer getLoanId(){
		return this.loanId;
	}

	public Date getLoanDate() {
		return loanDate;
	}

	public void setLoanDate(Date loanDate) {
		this.loanDate = loanDate;
	}
	
	public Date getReturnDate() {
		return returnDate;
	}

	public void setReturnDate(Date returnDate) {
		this.returnDate = returnDate;
	}
	
	public Date getPlannedReturnDate() {
		return plannedReturnDate;
	}

	public void setPlannedReturnDate(Date plannedReturnDate) {
		this.plannedReturnDate = plannedReturnDate;
	}
	
	public Double getLoanValue() {
		return loanValue;
	}

	public void setLoanValue(Double loanValue) {
		this.loanValue = loanValue;
	}
	
	public void setItens(Set<Item> itens){
		this.itens = itens;
	}
	
	public Set<Item> getItens(){
		return this.itens;
	}
	
	public void setUser(User user){
		this.user = user;
	}
	
	public User getUser(){
		return this.user;
	}
	
	public Fine getFine() {
		return fine;
	}

	public void setFine(Fine fine) {
		this.fine = fine;
	}

	@Override
	public String toString(){
		return this.loanId.toString();
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((loanId == null) ? 0 : loanId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		LoanImpl other = (LoanImpl) obj;
		if (loanId == null) {
			if (other.loanId != null)
				return false;
		} else if (!loanId.equals(other.loanId))
			return false;
		return true;
	}

	@Override
	public int compareTo(Object o) {
		
		return this.loanId.compareTo(((LoanImpl) o).getLoanId());
	}
}
