package com.rise.userbundle;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import com.rise.userbundle.dao.ProfileDao;
import com.rise.userbundle.dao.UserDao;

/**
 * 
 * @author Heberth Braga
 *
 */
public class UserServiceImpl implements UserService {
	
	private UserDao userDao;
	private ProfileDao profileDao;

	/**
	 * Sets the User Data Access Object
	 * @param userDao
	 */
	public void setUserDao(UserDao userDao) {
		this.userDao = userDao;
	}
	
	/**
	 * Sets the Profile Data Access Object
	 * @param profileDao
	 */
	public void setProfileDao(ProfileDao profileDao){
		this.profileDao = profileDao;
	}

	@Override
	public void addUser(User user) {
		this.userDao.saveUser(user);
	}

	@Override
	public User getUser(Integer id) {
		
		return this.userDao.getUser(id);
	}

	@Override
	public User getUserByName(String param) {
		
		return this.userDao.getUserByName(param);
	}

	@Override
	public List<User> getUsers() {
		
		return this.userDao.getUsers();
	}

	@Override
	public List<Object> getUsersByParameters(String str,
			Object[] parameters) {
		
		return this.userDao.getUsersByParameters(str, parameters);
	}

	@Override
	public void removeUser(User user) {
		this.userDao.removeUser(user);
	}

	@Override
	public void updateUser(User user) {
		this.userDao.updateUser(user);
	}

	@Override
	public void addProfile(Profile Profile) {
		this.profileDao.saveProfile(Profile);
	}

	@Override
	public Profile getProfile(Integer id) {
		
		return this.profileDao.getProfile(id);
	}

	@Override
	public List<Profile> getProfiles() {
		
		return this.profileDao.getProfiles();
	}

	@Override
	public void removeProfile(Profile profile) {
		this.profileDao.removeProfile(profile);
	}

	@Override
	public void updateProfile(Profile profile) {
		this.profileDao.updateProfile(profile);
	}
	
	@Override
	public boolean validateUser(String email, String password) {
		Object[] parameters = {email, password};

		String query = "from UserImpl u where u.email like ? " +
			"and u.password like ?";

		Collection<Object> result = getUsersByParameters(
				query, parameters);

		Iterator<Object> itResult = result.iterator();

		while(itResult.hasNext()){
			return true;
		}

		return false;
	}
}
