package com.rise.userbundle.dao.impl;

import java.util.List;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.rise.userbundle.User;
import com.rise.userbundle.dao.UserDao;
import com.rise.userbundle.entity.impl.UserImpl;

/**
 * 
 * @author Heberth Braga
 *
 */
public class UserDaoImpl extends HibernateDaoSupport 
	implements UserDao {

	@Override
	public User getUser(Integer id) {
	
		return (User) getHibernateTemplate().get(
				UserImpl.class, id);
	}

	@SuppressWarnings("unchecked")
	@Override
	public User getUserByName(String param) {
			
		String strQuery = "from UserImpl u where u.username = ?";
		
		List list = getHibernateTemplate().find(strQuery, param);

		if(list != null && list.size() > 0)
			return (User) list.get(0);
		else
			return null;
	}		

	@SuppressWarnings("unchecked")
	@Override
	public List<User> getUsers() {
		
		return getHibernateTemplate().loadAll(UserImpl.class);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<Object> getUsersByParameters(String str,
			Object[] parameters) {
		
		return getHibernateTemplate().find(str, parameters);
	}

	@Override
	public void removeUser(User user) {
		getHibernateTemplate().delete(user);
	}

	@Override
	public void saveUser(User user) {
		getHibernateTemplate().save(user);
	}

	@Override
	public void updateUser(User user) {
		getHibernateTemplate().update(user);
	}
}