package com.rise.serviceComponents.authenticationServiceComponent.impl;

import com.rise.serviceComponents.authenticationServiceComponent.Authentication;
import com.rise.serviceComponents.userServiceComponent.UserService;
import com.rise.serviceComponents.userServiceComponent.entity.User;

/**
 * 
 * @author Heberth Braga
 * 
 * Mandatory implementation of the Authentication interface. 
 *
 */

public class PasswordAuthentication extends Authentication {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7322120270939775914L;
	
	private User user;
	private UserService userService;
	
	public PasswordAuthentication(){
	
	}
	
	public void setUser(User user){
		this.user = user;
	}
	
	@Override
	public void setUserService(UserService userService){
		this.userService = userService;
	}

	@Override
	public boolean authenticate() {
		
		return this.userService.validateUser(this.user.getEmail(), 
				this.user.getPassword());
	}
}
