package com.rise.serviceComponents.fineServiceComponent;

import java.util.List;

import org.osoa.sca.annotations.Service;

import com.rise.serviceComponents.fineServiceComponent.entity.Fine;
import com.rise.serviceComponents.persistenceServiceComponent.PersistenceService;
import com.rise.serviceComponents.persistenceServiceComponent.dao.FineDao;

/**
 * 
 * @author Heberth Braga
 * @since 11/04/2009
 *
 */

@Service(FineService.class)
public class FineServiceImpl implements FineService {
	
	private DelegateFine delegateFine;
	private FineDao fineDao;
	
	public FineServiceImpl(PersistenceService persistenceService){
		this.fineDao = persistenceService.getFineDao();
	}
	
	public void setDelegateFine(DelegateFine delegateFine){
		this.delegateFine = delegateFine;
	}

	@Override
	public void addFine(Fine fine) {
		this.fineDao.save(fine);
	}

	@Override
	public void deleteFine(Fine fine) {
		this.fineDao.remove(fine);
	}

	@Override
	public Fine getFine(Integer id) {
		
		return (Fine) this.fineDao.retrieve(id);
	}

	@Override
	public List<Fine> getFines() {
		
		return this.fineDao.findAll();
	}
	
	@Override
	public DelegateFine getDelegateFine(){
		return this.delegateFine;
	}
}
