package com.rise.serviceComponents.itemServiceComponent;

import java.util.Map;

import com.rise.serviceComponents.itemServiceComponent.entity.ItemDetails;

/**
 * 
 * @author Heberth Braga
 *
 */
public class DelegateItemDetails {

	private ItemDetails fallbackDetails;
	private Map<Integer, ItemDetails> details;
	
	public void setFallbackDetails(ItemDetails fallbackDetails){
		this.fallbackDetails = fallbackDetails;
	}
	
	public void setDetails(Map<Integer, ItemDetails> details){
		this.details = details;
	}
	
	public ItemDetails getDetail(Integer key){
		if( key != null ){
			ItemDetails detail = this.details.get(key);
			
			if( detail == null ){
				detail = this.fallbackDetails;
			}
			
			return detail;
		}
		
		return null;
	}
}
