package com.rise.serviceComponents.itemServiceComponent.entity;
import java.util.Date;
import java.util.Set;

import com.rise.serviceComponents.loanServiceComponent.entity.Loan;

/**
 * 
 * @author Heberth Braga
 * 
 * Item Entity.
 *
 */

public class Item implements Comparable<Object> {

	private Integer itemId;
	private String name;
	private Date acquisitionDate;
	private Integer quantity;
	private Category category;
	private Integer rate;
	private Set<Loan> loans;
	
	public Item(){
		
	}
	
	public void setItemId(Integer itemId){
		this.itemId = itemId;
	}
	
	public Integer getItemId(){
		return this.itemId;
	}
	
	public void setName(String name){
		this.name = name;
	}
	
	public String getName(){
		return this.name;
	}
	
	public void setAcquisitionDate(Date acquisitionDate){
		this.acquisitionDate = acquisitionDate;
	}
	
	public Date getAcquisitionDate(){
		return this.acquisitionDate;
	}
	
	public void setQuantity(Integer quantity){
		this.quantity = quantity;
	}
	
	public Integer getQuantity(){
		return this.quantity;
	}
	
	public void setRate(Integer rate){
		this.rate = rate;
	}
	
	public Integer getRate(){
		return this.rate;
	}
	
	public void setCategory(Category category){
		this.category = category;
	}
	
	public Category getCategory(){
		return this.category;
	}
	
	public Set<Loan> getLoans(){
		return this.loans;
	}
	
	public void setLoans(Set<Loan> loans){
		this.loans = loans;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((itemId == null) ? 0 : itemId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Item other = (Item) obj;
		if (itemId == null) {
			if (other.itemId != null)
				return false;
		} else if (!itemId.equals(other.itemId))
			return false;
		return true;
	}

	@Override
	public int compareTo(Object o) {
		
		return this.itemId.compareTo(((Item) o).getItemId());
	}
}
