package com.rise.serviceComponents.persistenceServiceComponent;

import java.util.HashMap;

import org.hibernate.SessionFactory;

import com.rise.serviceComponents.persistenceServiceComponent.dao.FineDao;
import com.rise.serviceComponents.persistenceServiceComponent.dao.ItemDetailsDao;
import com.rise.serviceComponents.persistenceServiceComponent.dao.impl.CommentDaoImpl;
import com.rise.serviceComponents.persistenceServiceComponent.dao.impl.PenaltyForDelayDaoImpl;
import com.rise.serviceComponents.persistenceServiceComponent.dao.impl.PenaltyForViolationDaoImpl;

/**
 * 
 * @author Heberth Braga
 *
 */
public class FactoryVariationDaos {

	public static FineDao verifyFineDaoType(FineDao fineDao, 
			final SessionFactory sessionFactory){
		HashMap<Integer, FineDao> mapDaos = new HashMap<Integer, FineDao>();
		mapDaos.put(0, new PenaltyForDelayDaoImpl());
		mapDaos.put(1, new PenaltyForViolationDaoImpl());
		
		fineDao = mapDaos.get(0);

		if(fineDao instanceof PenaltyForDelayDaoImpl){
			((PenaltyForDelayDaoImpl) fineDao).
			setSessionFactory(sessionFactory);
			
			return fineDao;
		}else {
			fineDao = null;
			
			if(fineDao == null){
				fineDao = mapDaos.get(1);
				
				((PenaltyForViolationDaoImpl) fineDao).
				setSessionFactory(sessionFactory);
				
				return fineDao;
			}
		}
		
		return null;
	}
	
	public static ItemDetailsDao verifyItemDetailsDaoType(ItemDetailsDao detailsDao, 
			final SessionFactory sessionFactory){
		
		HashMap<Integer, ItemDetailsDao> mapDaos = new HashMap<Integer, ItemDetailsDao>();
		mapDaos.put(0, new CommentDaoImpl());
		
		detailsDao = mapDaos.get(0);
		
		if(detailsDao instanceof CommentDaoImpl){
			((CommentDaoImpl) detailsDao).
			setSessionFactory(sessionFactory);
			
			return detailsDao;
		}
		
		return null;
	}
}
