package com.rise.serviceComponents.persistenceServiceComponent;

import java.util.Collection;
import java.util.List;

/**
 * 
 * @author Heberth Braga

 * Generic persitence service.
 *
 */
public interface Persistence<T> {

	public void save(T entity);
	
	public void update(T entity);
	
	public Object retrieve(Object pk);
	
	public List<T> findAll();
	
	public void remove(T entity);
	
	public Collection<Object> retrieveByParameters(String str, 
				Collection<Object> parameters);
}