package com.rise.serviceComponents.persistenceServiceComponent.dao.impl;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;

import com.rise.serviceComponents.itemServiceComponent.entity.Item;
import com.rise.serviceComponents.loanServiceComponent.entity.Loan;
import com.rise.serviceComponents.persistenceServiceComponent.dao.LoanDao;
import com.rise.serviceComponents.persistenceServiceComponent.hibernate.GeneralDaoHibernate;
import com.rise.serviceComponents.userServiceComponent.entity.User;

/**
 * 
 * @author Heberth Braga
 *
 */
public class LoanDaoImpl extends GeneralDaoHibernate<Loan>
	implements LoanDao {

	@SuppressWarnings("unchecked")
	@Override
	public Class getEntityClass() {
		
		return Loan.class;
	}

	@Override
	public Set<Item> getItensLoan(Loan loan) {
		
		String result = "Select l.itens from Loan l where l.loanid " +
		"= :param0";

		Collection<Object> parameters = new ArrayList<Object>();
		parameters.add(loan.getLoanId());

		Set<Item> itensList = new TreeSet<Item>();

		try {
			Collection<Object> collection = this.
				retrieveByParameters(result, parameters);

			Iterator<Object> itResult = collection.iterator();

			while(itResult.hasNext()){
				Object obj = itResult.next();
				itensList.add((Item) obj);
			}

			return itensList;

		} catch (Exception e) {
			e.printStackTrace();
		}

		return null;
	}

	@Override
	public Set<Loan> getLoanByUser(User user) {
		
		String result = "from Loan l where l.user.name = :param0";
		
		Collection<Object> parameters = new ArrayList<Object>();
		parameters.add(user.getName());
		
		Set<Loan> loansList = new TreeSet<Loan>();
		
		try {
			Collection<Object> collection = this.
					retrieveByParameters(result, parameters);
			
			Iterator<Object> itResult = collection.iterator();
			
			while(itResult.hasNext()){
				Object obj = itResult.next();
				loansList.add((Loan) obj);
			}
			
			return loansList;
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return null;
	}
}
