package com.rise.serviceComponents.persistenceServiceComponent.dao.impl;

import java.util.List;

import com.rise.serviceComponents.persistenceServiceComponent.dao.UserDao;
import com.rise.serviceComponents.persistenceServiceComponent.hibernate.GeneralDaoHibernate;
import com.rise.serviceComponents.userServiceComponent.entity.User;

/**
 * 
 * @author Heberth Braga
 *
 */
public class UserDaoImpl extends GeneralDaoHibernate<User>
	implements UserDao {

	@SuppressWarnings("unchecked")
	@Override
	public Class getEntityClass() {
		
		return User.class;
	}

	@SuppressWarnings("unchecked")
	@Override
	public User getUserByName(String name) {
		
		String strQuery = "from User u where u.username = ?";

		List list = getHibernateTemplate().find(strQuery, name);

		if(list != null && list.size() > 0)
			return (User) list.get(0);
		else
			return null;
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<Object> getUsersByParameters(String str, Object[] parameters) {
		
		return getHibernateTemplate().find(str, parameters);
	}
}
