package com.rise.serviceComponents.persistenceServiceComponent.hibernate;

import java.io.Serializable;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;

import com.rise.serviceComponents.persistenceServiceComponent.Persistence;

/**
 * 
 * @author Heberth Braga
 *
 * @param <T>
 */
public abstract class GeneralDaoHibernate<T> extends HibernateDaoSupport
	implements Persistence<T> {

	public GeneralDaoHibernate(){
		
	}
	
	public Session getCurrentSession(){
		return getHibernateTemplate().getSessionFactory().
				getCurrentSession();
	}
	
	@SuppressWarnings("unchecked")
	public abstract Class getEntityClass();

	@SuppressWarnings("unchecked")
	@Override
	public List<T> findAll() {
		
		Session session = getCurrentSession();
		
		try {
			String strQuery = "from " + getEntityClass().getSimpleName();
			
			Query query = session.createQuery(strQuery);
			List<T> list = query.list();
		
			return list;
		} catch(HibernateException he){
			
			he.printStackTrace();
		}
		
		return null;
	}

	@Override
	public void remove(T entity) {
		
		try{
			this.getCurrentSession().delete(entity);
			
		} catch(HibernateException he){
			
			he.printStackTrace();
			he.getCause();
		} 
	}

	@SuppressWarnings("unchecked")
	@Override
	public Object retrieve(Object pk) {
		try {
		
			final T entity = (T) this.getCurrentSession().get(
					getEntityClass(), (Serializable)pk); 
			
			return entity;
		} catch(HibernateException he){
			
			he.printStackTrace();
		}
		
		return null;
	}

	@SuppressWarnings("unchecked")
	@Override
	public Collection<Object> retrieveByParameters(String str,
			Collection<Object> parameters) {
		
		int i = 0;
		
		try {
			
			Query query = getCurrentSession().createQuery(str);
			
			Iterator<Object> itParameters = parameters.iterator();
			
			while(itParameters.hasNext()){
				Object param = itParameters.next();
				String result = "param" + i;
				
				if(param instanceof Integer){
					query.setInteger(result, ((Integer) param));
				} else if (param instanceof Double) {
					query.setDouble(result, ((Double) param));
				} else if (param instanceof Long) {
					query.setLong(result, ((Long) param));
				} else if (param instanceof String) {
					query.setString(result, ((String) param));
				} else if (param instanceof Boolean) {
					query.setBoolean(result, ((Boolean) param));
				}
				i++;
			}
			
			return query.list();
			
		} catch(HibernateException he){
			
			he.printStackTrace();
		} 
		
		return null;
	}

	@Override
	public void save(T entity) {
		
		try{
			this.getCurrentSession().save(entity);
			
		} catch(HibernateException he){
			
			he.printStackTrace();
		}
	}

	@Override
	public void update(T entity) {
		
		try{
			this.getCurrentSession().update(entity);
			
		} catch(HibernateException he){
			
			he.printStackTrace();
		}
	}
}
