package com.rise.serviceComponents.persistenceServiceComponent.impl;

import org.hibernate.SessionFactory;

import com.rise.serviceComponents.persistenceServiceComponent.FactoryVariationDaos;
import com.rise.serviceComponents.persistenceServiceComponent.PersistenceService;
import com.rise.serviceComponents.persistenceServiceComponent.dao.CategoryDao;
import com.rise.serviceComponents.persistenceServiceComponent.dao.FineDao;
import com.rise.serviceComponents.persistenceServiceComponent.dao.ItemDao;
import com.rise.serviceComponents.persistenceServiceComponent.dao.ItemDetailsDao;
import com.rise.serviceComponents.persistenceServiceComponent.dao.LoanDao;
import com.rise.serviceComponents.persistenceServiceComponent.dao.ProfileDao;
import com.rise.serviceComponents.persistenceServiceComponent.dao.UserDao;
import com.rise.serviceComponents.persistenceServiceComponent.dao.impl.CategoryDaoImpl;
import com.rise.serviceComponents.persistenceServiceComponent.dao.impl.CommentDaoImpl;
import com.rise.serviceComponents.persistenceServiceComponent.dao.impl.ItemDaoImpl;
import com.rise.serviceComponents.persistenceServiceComponent.dao.impl.LoanDaoImpl;
import com.rise.serviceComponents.persistenceServiceComponent.dao.impl.ProfileDaoImpl;
import com.rise.serviceComponents.persistenceServiceComponent.dao.impl.UserDaoImpl;


/**
 * 
 * @author Heberth Braga
 * 
 *
 */
public class PersistenceServiceImpl implements PersistenceService {
	
	private UserDao userDao;
	private ItemDao itemDao;
	private CategoryDao categoryDao;
	private ItemDetailsDao itemDetailsDao;
	private FineDao fineDao;
	private LoanDao loanDao;
	private ProfileDao profileDao;
		
	public PersistenceServiceImpl(final SessionFactory sessionFactory){
		this.userDao = new UserDaoImpl();
		((UserDaoImpl) userDao).setSessionFactory(sessionFactory);
		
		this.itemDao = new ItemDaoImpl();
		((ItemDaoImpl) itemDao).setSessionFactory(sessionFactory);
		
		this.categoryDao = new CategoryDaoImpl();
		((CategoryDaoImpl) categoryDao).setSessionFactory(sessionFactory);
		
		this.loanDao = new LoanDaoImpl();
		((LoanDaoImpl) loanDao).setSessionFactory(sessionFactory);
		
		this.itemDetailsDao = new CommentDaoImpl();
		((CommentDaoImpl) itemDetailsDao).setSessionFactory(sessionFactory);
		
		this.fineDao = FactoryVariationDaos.verifyFineDaoType(this.fineDao, sessionFactory);
		
		FactoryVariationDaos.verifyItemDetailsDaoType(this.itemDetailsDao, 
				sessionFactory);
		
		this.profileDao = new ProfileDaoImpl();
		((ProfileDaoImpl) profileDao).setSessionFactory(sessionFactory);
	}
	
	@Override
	public CategoryDao getCategoryDao() {
		
		return this.categoryDao;
	}

	@Override
	public ItemDetailsDao getItemDetailsDao() {
		
		return this.itemDetailsDao;
	}

	@Override
	public ItemDao getItemDao() {
		
		return this.itemDao;
	}

	@Override
	public LoanDao getLoanDao() {
		
		return this.loanDao;
	}

	@Override
	public FineDao getFineDao() {
		
		return this.fineDao;
	}

	@Override
	public UserDao getUserDao() {
		
		return this.userDao;
	}

	@Override
	public ProfileDao getProfileDao() {
		
		return this.profileDao;
	}
}
