package com.rise.serviceComponents.userServiceComponent;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import com.rise.serviceComponents.userServiceComponent.entity.Profile;
import com.rise.serviceComponents.userServiceComponent.entity.User;

/**
 * 
 * @author Heberth Braga
 * 
 * User service.
 *
 */
public interface UserService extends Serializable {

	public void addUser(User user);
	
	public User getUser(Integer id);
	
	public List<User> getUsers();
	
	public User getUserByName(String param);
	
	public void addProfile(Profile Profile);
	
	public Profile getProfile(Integer id);
	
	public List<Profile> getProfiles();
	
	public Collection<Object> getUsersByParameters(String str, 
			Object[] parameters);
	
	public void removeProfile(Profile profile);
	
	public void removeUser(User user);
	
	public void updateUser(User user);
	
	public void updateProfile(Profile profile);
	
	public boolean validateUser(String email, String password);
}
