package com.rise.spring;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;

import com.rise.spring.exceptions.ServiceNotFoundException;

/**
 * 
 * @author Heberth Braga
 *
 */
public class SCAApplicationContextProvider implements ApplicationContextAware {
	
	private static ApplicationContext context;
	
	@Override
	public void setApplicationContext(ApplicationContext appContext)
			throws BeansException {
		context = appContext;
	}
	
	public static ApplicationContext getApplicationContext(){
		return context;
	}
	
	public static Object getService(String name, ApplicationContext ctx) 
				throws ServiceNotFoundException {
		Object service;

		// Verify if the bean exists
		if (!ctx.containsBean(name)) {
			throw new ServiceNotFoundException("bean does not exist!!");
		}

		// Instantiate the service
		service = ctx.getBean(name);

		return service;
	}
}
