package com.rise.serviceComponents.itemServiceComponent;

import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import org.springframework.context.ApplicationContext;

import com.rise.server.ServicesServer;
import com.rise.serviceComponents.itemServiceComponent.entity.Category;
import com.rise.serviceComponents.itemServiceComponent.entity.Comment;
import com.rise.serviceComponents.itemServiceComponent.entity.Item;
import com.rise.serviceComponents.itemServiceComponent.entity.ItemDetails;
import com.rise.serviceComponents.userServiceComponent.UserService;
import com.rise.serviceComponents.userServiceComponent.entity.User;
import com.rise.spring.SCAApplicationContextProvider;
import com.rise.spring.exceptions.ServiceNotFoundException;

public class Client {

	public static void main(String[] args) {
		ServicesServer server = new ServicesServer();

		server.createNodeFactory();
		server.createNode("R4llTuscany.composite");
		server.getNode().start();

		ApplicationContext ctx = SCAApplicationContextProvider.getApplicationContext();
		
		try {
			
			ItemService itemService = (ItemService) SCAApplicationContextProvider.
					getService("ItemServiceBean", ctx);
			
			UserService userService = (UserService) SCAApplicationContextProvider.
					getService("UserServiceBean", ctx);
			
			Category category = itemService.getCategory(2);
			List<Item> listItem = itemService.getItens();
			
			Item item = new Item();
			item.setName("Math Fundaments - Schwocovisk");
			item.setQuantity(4);
			item.setAcquisitionDate(new Date());
			
			Set<Item> itens = new TreeSet<Item>(listItem);
			
			category.setItens(itens);
			
			item.setCategory(category);
			
			Item i = itemService.getItem(4);
			
			User user = userService.getUser(3);
			
			Collection<ItemDetails> temp = itemService.getItemDetailsTypes();
			Iterator<ItemDetails> itResult = temp.iterator();
			
			while(itResult.hasNext()){
				/*Review review = (Review) itResult.next(); 
				
				review.setTitle("Calculo 2");
				review.setCharacters("Bla bla bla");
				review.setItem(i);
				review.setUser(user);
				review.setPicture("calculo.jpg");
				
				itemService.insertItemDetails(review);*/
				
				Comment comment = (Comment) itResult.next();
				
				comment.setNickname("Lucas");
				comment.setTitle("Lokks");
				comment.setCharacters("Test Metrics");
				comment.setItem(i);
				comment.setUser(user);

				itemService.insertItemDetails(comment);
			}
		} catch (ServiceNotFoundException e) {
			e.printStackTrace();
		}
		
		server.getNode().stop();
	}
}
