package container;

import org.junit.Test;
import org.springframework.context.ApplicationContext;

import com.rise.server.ServicesServer;
import com.rise.serviceComponents.userServiceComponent.UserService;
import com.rise.spring.SCAApplicationContextProvider;
import com.rise.spring.exceptions.ServiceNotFoundException;

/**
 * 
 * @author Heberth Braga
 *
 */
public class ScaContainerStarterTestCase {
	
	private ServicesServer server;
	private ApplicationContext ctx;
	private UserService userService;
	
	@Test
	public void testPing() throws ServiceNotFoundException {
		server = new ServicesServer();
		
		server.createNodeFactory();
		server.createNode("R4llTuscany.composite");
		server.getNode().start();
		
		ctx = SCAApplicationContextProvider.getApplicationContext();
		
		userService = (UserService) SCAApplicationContextProvider.
				getService("UserServiceBean", ctx);
		
		System.out.println("UserService.class" + userService.getClass());
		
		System.out.println("It works!!");
		
		server.getNode().stop();
	}
}
