package com.rise.serviceComponents.authenticationServiceComponent;

import com.rise.serviceComponents.userServiceComponent.User;
import com.rise.serviceComponents.userServiceComponent.UserService;

/**
 * 
 * @author Heberth Braga
 * 
 * Mandatory implementation of the Authentication interface. 
 *
 */

public class PasswordAuthentication implements Authentication {

	private UserService userService;
	private User user;
	
	public PasswordAuthentication(User user){
		this.user = user;
	}
	
	@Override
	public void setUserService(UserService userService){
		this.userService = userService;
	}
	
	@Override
	public boolean authenticate() {
		
		return this.userService.validateUser(this.user.getEmail(),
				this.user.getPassword());
	}
}
