package com.rise.serviceComponents.fineServiceComponent;

import java.util.Calendar;
import java.util.GregorianCalendar;

/**
 * 
 * @author Heberth Braga
 * 
 * Mandatory implementation of the Fine feature.
 *
 */
public class PenaltyForDelay extends Fine {
	
	public PenaltyForDelay(){
		
	}
	
	@Override
	public Double calculateFineValue(Object[] parameters) {
		Integer dayOfMonth = (Integer) parameters[0];
		Integer month = (Integer) parameters[1];
		java.util.Date loanDate = (java.util.Date) parameters[2];

		Integer numberOfDays = calculateNumberDays(dayOfMonth, month, loanDate);

		return this.fineValue * numberOfDays;
	}
	
	private Integer calculateNumberDays(int dayOfMonth, int month, java.util.Date loanDate){
		
		Calendar deliveryDate = new GregorianCalendar();
		
		deliveryDate.set(Date.getDayOfMonth(), dayOfMonth);
		deliveryDate.set(Date.getMonth(), month);
		
		Long diff = deliveryDate.getTimeInMillis() - loanDate.getTime();
		diff = diff / 100 / 60 / 60 / 24;
		
		return Integer.valueOf(diff.toString());
	}
}
