package container;

import org.junit.Test;
import org.springframework.context.ApplicationContext;
import static org.hamcrest.core.Is.is;
import static org.junit.Assert.assertThat;

import com.rise.server.ServicesServer;
import com.rise.serviceComponents.authenticationServiceComponent.AuthenticationService;
import com.rise.serviceComponents.fineServiceComponent.FineService;
import com.rise.serviceComponents.itemServiceComponent.ItemService;
import com.rise.serviceComponents.loanServiceComponent.LoanService;
import com.rise.serviceComponents.userServiceComponent.UserService;
import com.rise.spring.SCAApplicationContextProvider;
import com.rise.spring.ServiceNotFoundException;

/**
 * 
 * @author Heberth Braga
 *
 */
public class ScaContainerStarterTestCase {
	
	private ServicesServer server;
	private ApplicationContext ctx;
	private UserService userService;
	private ItemService itemService;
	private FineService fineService;
	private LoanService loanService;
	private AuthenticationService authService;
	
	@Test
	public void testPing() throws ServiceNotFoundException {
		server = new ServicesServer();
		
		server.createNodeFactory();
		server.createNode("R4llTuscanyConfig.composite");
		server.getNode().start();
		
		ctx = SCAApplicationContextProvider.getApplicationContext();
		
		userService = (UserService) SCAApplicationContextProvider.
				getService("UserServiceBean", ctx);
		
		itemService = (ItemService) SCAApplicationContextProvider.
				getService("ItemServiceBean", ctx);
		
		loanService = (LoanService) SCAApplicationContextProvider.
				getService("LoanServiceBean", ctx);
		
		authService = (AuthenticationService) SCAApplicationContextProvider.
				getService("AuthenticationServiceBean", ctx);
		
		fineService = (FineService) SCAApplicationContextProvider.
				getService("FineServiceBean", ctx);
		
		assertThat(userService != null, is(true));
		assertThat(fineService != null, is(true));
		assertThat(itemService != null, is(true));
		assertThat(loanService != null, is(true));
		assertThat(authService != null, is(true));
	}
}
