package com.rise.serviceComponents.authenticationServiceComponent;

import com.rise.serviceComponents.userServiceComponent.User;
import com.rise.serviceComponents.userServiceComponent.UserService;

/**
 * 
 * @author Heberth Braga
 * 
 * Mandatory implementation of the Authentication interface. 
 *
 */
public class PasswordAuthentication extends Authentication {

	private User user;
	private UserService userService;
	
	public PasswordAuthentication(User user, UserService userService){
		this.user = user;
		this.userService = userService;
	}
	
	@Override
	public boolean authenticate() {

		return this.userService.validateUser(this.user.getEmail(), 
				this.user.getPassword());
	}
}
