package com.rise.serviceComponents.fineServiceComponent;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

/**
 * 
 * @author Heberth Braga
 * 
 * Mandatory implementation of the Fine feature.
 *
 */
public class PenaltyForDelay extends FineBase implements Fine {
	
	private Double fineValue;
	private Double calculatedFineValue;
	private Integer id;
	
	public PenaltyForDelay(Integer dayOfMonth, Integer month, Date loanDate) {
		super(dayOfMonth, month, loanDate);
	}
	
	@Override
	public void setId(Integer id){
		this.id = id;
	}
	
	@Override
	public Integer getId(){
		return this.id;
	}

	@Override
	public Double calculateFineValue() {
		Integer numberOfDays = calculateNumberDays(getDayOfMonth(), getMonth(), 
				getLoanDate());

		return this.fineValue * numberOfDays;
	}

	@Override
	public void setCalculatedFineValue(Double value) {
		this.calculatedFineValue = value;
	}

	@Override
	public void setFineValue(Double fineValue) {
		this.fineValue = fineValue;
	}
	
	private Integer calculateNumberDays(Integer dayOfMonth, Integer month, 
			java.util.Date loanDateTime){
		
		Calendar deliveryDate = new GregorianCalendar();
		
		deliveryDate.set(GregorianCalendar.DAY_OF_MONTH, dayOfMonth);
		deliveryDate.set(com.rise.serviceComponents.fineServiceComponent.Date.getMonth(), month);
		
		Long diff = deliveryDate.getTimeInMillis() - loanDateTime.getTime();
		diff = diff / 100 / 60 / 60 / 24;
		
		return Integer.valueOf(diff.toString());
	}

	@Override
	public Double getCalculatedFineValue() {
		
		return this.calculatedFineValue;
	}

	@Override
	public Double getFineValue() {
		
		return this.fineValue;
	}
}
