package com.rise.serviceComponents.loanServiceComponent;

import java.io.Serializable;
import java.util.List;
import java.util.Set;

import com.rise.serviceComponents.fineServiceComponent.Fine;
import com.rise.serviceComponents.itemServiceComponent.Item;
import com.rise.serviceComponents.itemServiceComponent.ItemService;
import com.rise.serviceComponents.userServiceComponent.User;

/**
 * 
 * @author Heberth Braga
 * @since 30/03/2009
 * 
 * Renting service.
 *
 */
public interface LoanService extends Serializable {
	
	public void addLoan(Loan loan);
	
	public Loan getLoan(Integer id);
	
	public List<Loan> getLoans();
	
	public Set<Loan> getLoanByUser(User user);
	
	public void returnLoanItem(Loan loan, ItemService service);
	
	public Set<Item> getItensLoan(Loan loan);
	
	public void addFine(Fine fine);
	
	public void calculateFine(Double fineValue);
}
