package com.rise.serviceComponents.persistence;

import com.rise.serviceComponents.persistence.dao.CategoryDao;
import com.rise.serviceComponents.persistence.dao.FineDao;
import com.rise.serviceComponents.persistence.dao.ItemDao;
import com.rise.serviceComponents.persistence.dao.ItemDetailsDao;
import com.rise.serviceComponents.persistence.dao.LoanDao;
import com.rise.serviceComponents.persistence.dao.ProfileDao;
import com.rise.serviceComponents.persistence.dao.UserDao;

/**
 * 
 * @author Heberth Braga
 * 
 * Service that act as a Factory for the instantiation
 * of the DAO classes.
 *
 */
public interface PersistenceService {

	public UserDao getUserDao();
	
	public ItemDao getItemDao();
	
	public ItemDetailsDao getItemDetailsDao();
	
	public LoanDao getLoanDao();
	
	public FineDao getFineDao();
	
	public CategoryDao getCategoryDao();
	
	public ProfileDao getProfileDao();
}
