package com.rise.serviceComponents.userServiceComponent;

import java.util.Set;

import com.rise.serviceComponents.loanServiceComponent.Loan;

/**
 * 
 * @author Heberth Braga
 * @since 30/03/2009
 * 
 * Entity User.
 *
 */

public class User implements Comparable<Object> {

	private Integer userId;
	private String name;
	private String email;
	private String address;
	private String telephone;
	private String password;
	private Profile profile;
	private Set<Loan> loans;

	public User(){
		
	}
	
	public void setUserId(Integer userId){
		this.userId = userId;
	}
	
	public Integer getUserId(){
		return this.userId;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public String getTelephone() {
		return telephone;
	}

	public void setTelephone(String telephone) {
		this.telephone = telephone;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}
	
	public void setProfile(Profile profile){
		this.profile = profile;
	}
	
	public Profile getProfile(){
		return this.profile;
	}
	
	public Set<Loan> getLoans(){
		return this.loans;
	}
	
	public void setLoans(Set<Loan> loans){
		this.loans = loans;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((userId == null) ? 0 : userId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		User other = (User) obj;
		if (userId == null) {
			if (other.userId != null)
				return false;
		} else if (!userId.equals(other.userId))
			return false;
		return true;
	}

	@Override
	public int compareTo(Object o) {
		
		return this.userId.compareTo(((User) o).getUserId());
	}
}
