package com.rise.serviceComponents.userServiceComponent;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.osoa.sca.annotations.Service;

import com.rise.serviceComponents.persistence.PersistenceService;
import com.rise.serviceComponents.persistence.dao.ProfileDao;
import com.rise.serviceComponents.persistence.dao.UserDao;

@Service(UserService.class)
public class UserServiceImpl implements UserService {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -6868295323630247938L;
	
	private UserDao userDao;
	private ProfileDao profileDao;
	
	public UserServiceImpl(PersistenceService persistenceService){
		this.userDao = persistenceService.getUserDao();
		this.profileDao = persistenceService.getProfileDao();
	}

	@Override
	public void addProfile(Profile profile) {
		this.profileDao.save(profile);
	}

	@Override
	public void addUser(User user) {
		this.userDao.save(user);
	}

	@Override
	public Profile getProfile(Integer id) {
		
		return (Profile) this.profileDao.retrieve(id);
	}

	@Override
	public List<Profile> getProfiles() {
		
		return this.profileDao.findAll();
	}

	@Override
	public User getUser(Integer id) {
		
		return (User) this.userDao.retrieve(id);
	}

	@Override
	public List<User> getUsers() {
		
		return this.userDao.findAll();
	}

	@Override
	public Collection<Object> getUsersByParameters(String str,
			Object[] parameters) {
	
		return this.userDao.getUsersByParameters(str, 
				parameters);
	}

	@Override
	public User getUserByName(String param) {
		
		return this.userDao.getUserByName(param);
	}

	@Override
	public void removeProfile(Profile profile) {
		this.profileDao.remove(profile);
	}

	@Override
	public void removeUser(User user) {
		this.userDao.remove(user);
	}

	@Override
	public void updateProfile(Profile profile) {
		this.profileDao.update(profile);
	}

	@Override
	public void updateUser(User user) {
		this.userDao.update(user);
	}
	
	@Override
	public boolean validateUser(String email, String password) {
		Object[] parameters = {email, password};

		String query = "from User u where u.email like ? " +
			"and u.password like ?";

		Collection<Object> result = getUsersByParameters(
				query, parameters);

		Iterator<Object> itResult = result.iterator();

		while(itResult.hasNext()){
			return true;
		}

		return false;
	}
}
