package com.rise.serviceComponents.authenticationServiceComponent;

import static org.hamcrest.core.Is.is;
import static org.junit.Assert.assertThat;

import org.junit.Before;
import org.junit.Test;
import org.springframework.context.ApplicationContext;

import com.rise.server.ServicesServer;
import com.rise.serviceComponents.userServiceComponent.User;
import com.rise.serviceComponents.userServiceComponent.UserService;
import com.rise.spring.SCAApplicationContextProvider;
import com.rise.spring.ServiceNotFoundException;

public class AuthenticationServiceTest {
	
	private AuthenticationService authService;
	private ServicesServer server;
	private ApplicationContext ctx;
	private UserService userService;
	
	@Before
	public void setUp() throws ServiceNotFoundException{
		server = new ServicesServer();
		
		server.createNodeFactory();
		server.createNode("R4llTuscanyStrategy.composite");
		server.getNode().start();
		
		ctx = SCAApplicationContextProvider.getApplicationContext();
		
		authService = (AuthenticationService) SCAApplicationContextProvider.
				getService("AuthenticationServiceBean", ctx);
		
		userService = (UserService) SCAApplicationContextProvider.
				getService("UserServiceBean", ctx);
	}
	
	@Test
	public void testAuthenticateUser(){
		
		User user = new User();
		user.setEmail("foo@gmail.com");
		user.setPassword("1234");
		
		Authentication auth = new PasswordAuthentication(user, userService);
		
		authService.setAuthentication(auth);
		boolean isAuthorizedPassword = authService.authenticate();
		
		assertThat(isAuthorizedPassword, is(true));
	}
}
